Bug 1283350 - CVE-2015-7515 Local RedHat Enterprise Linux DoS - RHEL 7.1 Kernel crashes on invalid USB device descriptors (aiptek driver) [local-DoS]
CVE-2015-7515 Local RedHat Enterprise Linux DoS - RHEL 7.1 Kernel crashes on ...
Status: CLOSED WONTFIX
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: kernel (Show other bugs)
7.1
Unspecified Unspecified
unspecified Severity high
: rc
: 7.3
Assigned To: Don Zickus
Mike Gahagan
: Security, SecurityTracking
: 1283391 (view as bug list)
Depends On:
Blocks: CVE-2015-7515
  Show dependency treegraph
 
Reported: 2015-11-18 14:15 EST by Ralf Spenneberg
Modified: 2016-05-09 05:03 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Release Note
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-03-11 07:29:44 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Reproduce Key for vUSBf framework (200 bytes, text/plain)
2015-11-18 14:15 EST, Ralf Spenneberg
no flags Details
Stacktrace (4.57 KB, text/plain)
2015-11-18 14:17 EST, Ralf Spenneberg
no flags Details
Arduino firmware demonstrating the bug (16.66 KB, text/plain)
2015-11-18 14:19 EST, Ralf Spenneberg
no flags Details
aiptek-null-deref.patch (1.76 KB, patch)
2015-11-25 11:06 EST, Vladis Dronov
no flags Details | Diff

  None (edit)
Description Ralf Spenneberg 2015-11-18 14:15:31 EST
Created attachment 1096204 [details]
Reproduce Key for vUSBf framework

Description of problem:
Local RedHat Enterprise Linux DoS – RHEL 7.1 Kernel crashes on invalid 
USB device descriptors (aiptek driver) [local-DoS]

Version-Release number of selected component (if applicable):
3.10.0-229.20.1.el7.x86_64 

How reproducible:
always


Advisory:
```
OpenSource Security Ralf Spenneberg
Am Bahnhof 3-5
48565 Steinfurt
info@os-s.net


Date: November 12th, 2015
Authors: Sergej Schumilo, Hendrik Schwartke, Ralf Spenneberg
CVE: not yet assigned
CVSS: 4.9 (AV:L/AC:L/Au:N/C:N/I:N/A:C) 
Title: Local RedHat Enterprise Linux DoS – RHEL 7.1 Kernel crashes on invalid 
USB device descriptors (aiptek driver) [local-DoS]
Severity: Critical. The Kernel panics. A reboot is required.
Ease of Exploitation: Trivial
Vulnerability type: Wrong input validation
Products: RHEL 7.1 including all updates
Kernel-Version: 3.10.0-229.20.1.el7.x86_64 
(for debugging-purposes we used the CentOS Kernel kernel-debuginfo-3.10.0-229.14.1.el7)


Abstract
The Kernel 3.10.0-229.20.1.el7.x86_64 crashes when presented a buggy USB 
device which requires the aiptek driver.
Detailed product description
We confirmed the bug on the following system:
RHEL 7.1
Kernel = 3.10.0-229.20.1.el7.x86_64
Further products or kernel versions have not been tested.
How reproducible: Always
Actual results: Kernel crashes 

Description:
The bug was found using the USB-fuzzing framework vUSBf from Sergej Schumilo 
(github.com/schumilo) using the following device descriptor:

 ######### PAYLOAD 1 #########
[*] Device-Descriptor
  bLength:		0x12
  bDescriptorType:	0x1
  bcdUSB:		0x200
  bDeviceClass:		0x3
  bDeviceSubClass:	0x0
  bDeviceProtocol:	0x0
  bMaxPacketSize:	0x40
  idVendor:		0x458
  idProduct:		0x5003
  bcdDevice:		0x100
  iManufacturer:	0x1
  iProduct:		0x2
  iSerialNumbers:	0x3
  bNumConfigurations:	0x1

This is the configuration descriptor containing the malicious value for 
bNumEndpoints causing the crash. A zero value for bNumEndpoints crashes the system.

	[*] Configuration-Descriptor
	  bLength:		0x9
	  bDescriptorType:	0x2
	  wTotalLength:		0x27
	  bNumInterfaces:	0x1
	  bConfigurationValue:	0x1
	  iConfiguration:	0x0
	  bmAttributes:		0x0
	  bMaxPower:		0x31
		[*] Interface-Descriptor
		  bLength:		0x9
		  bDescriptorType:	0x4
		  bInterfaceNumber:	0x0
		  bAlternateSetting:	0x0
		  bNumEndpoints:	0x0
		  bInterfaceClass:	0x0
		  bInterfaceSubClass:	0x0
		  bInterfaceProtocol:	0x0
			[*] Endpoint-Descriptor
			  bLength:		0x7
			  bDescriptorType:	0x5
			  bEndpointAddress:	0x81
			  bmAttribut:		0x3
			  wMaxPacketSize:	0x404
			  bInterval:		0xc
			[*] Endpoint-Descriptor
			  bLength:		0x7
			  bDescriptorType:	0x5
			  bEndpointAddress:	0x1
			  bmAttribut:		0x2
			  wMaxPacketSize:	0x4
			  bInterval:		0xc
			[*] Endpoint-Descriptor
			  bLength:		0x7
			  bDescriptorType:	0x5
			  bEndpointAddress:	0x82
			  bmAttribut:		0x1
			  wMaxPacketSize:	0x4
			  bInterval:		0xc

The aiptek driver assumes that there will be at least one endpoint-descriptor.
If the interface-descriptor contains a zero-value for bNumEndpoints or no endpoint-descriptor is provided, the driver tries to dereference a null-pointer and the kernel crashes:

****
$ nm aiptek.ko.debug | grep aiptek_probe
0000000000001ea0 t aiptek_probe
$ addr2line -e aiptek.ko.debug 2303
/usr/src/debug/kernel-3.10.0-229.14.1.el7/linux-3.10.0-229.14.1.el7.x86_64/drivers/input/tablet/aiptek.c:1830
****

**** CentOS-Kernel linux-3.10.0-229.14.1.el7 (drivers/input/tablet/aiptek.c)


1822	endpoint = &intf->altsetting[0].endpoint[0].desc; /* Nullpointer */
1823
1824	/* Go set up our URB, which is called when the tablet receives
1825	 * input.
1826	 */
1827	usb_fill_int_urb(aiptek->urb,
1828			 aiptek->usbdev,
1829			 usb_rcvintpipe(aiptek->usbdev,
1830					endpoint->bEndpointAddress), /* Nullpointer-Dereference */
1831			 aiptek->data, 8, aiptek_irq, aiptek,
1832			 endpoint->bInterval);
****

Proof of Concept:
1) The bug can be reproduced using USB-fuzzing framework vUSBf from Sergej Schumilo (github.com/schumilo). 
The attached vUSBf-obj file contains the payload. Please let us know if you would like to use the Facedancer board. 
In such case, we could also provide a patched version of vUSBf which allows to reproduce vUSBf-Payloads using the Facedancer board.
2) For a proof of concept we are providing also an Arduino firmware file. Just flash it 
on Arduino Leonardo and plug it into any RHEL machine. The Arduino will 
emulate the defective USB device.

   avrdude -v -p ATMEGA32u4 -c avr109 -P /dev/ttyACM0 -b 57600 -U flash:w:binary.hex

The file binary.hex has been attached to this bug report.
To prevent automated sending of payloads, use a jumper to connect port D3 and 
5V!


Severity and Ease of Exploitation
The security weakness can be easily exploited. Using our Arduino firmware only 
physical access to the system is required. 


Additional info:
Stacktrace, vUSBf-Payload, Arduino-Firmware attached.


Please assign a CVE for this issue since this is a local DoS of the targeted system. 
CVSS 4.9 (AV:L/AC:L/Au:N/C:N/I:N/A:C)
Comment 1 Ralf Spenneberg 2015-11-18 14:17 EST
Created attachment 1096205 [details]
Stacktrace
Comment 2 Ralf Spenneberg 2015-11-18 14:19 EST
Created attachment 1096206 [details]
Arduino firmware demonstrating the bug
Comment 3 Vladis Dronov 2015-11-24 11:02:03 EST
*** Bug 1283391 has been marked as a duplicate of this bug. ***
Comment 4 Vladis Dronov 2015-11-25 11:06 EST
Created attachment 1098887 [details]
aiptek-null-deref.patch
Comment 5 Vladis Dronov 2015-11-25 18:15:21 EST
Proposed upstream patch: http://www.spinics.net/lists/linux-input/msg42294.html
Comment 6 Vladis Dronov 2016-03-11 07:29:44 EST
Thank you for reporting this flaw.

The Product Security has rated this flaw as having low security impact (bz#1285326), so the patch currently is not planned to be added to the RHEL source trees. The upstream and Fedora patches are completed (at least, I hope so), so the patch may get to the RHEL trees at the next USB subsystem code rebase.

Note You need to log in before you can comment on or make changes to this bug.